{% extends 'dashboard/dashboard_content.html' %}

{% block head_block %}
    <link href="https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.3/css/select2.min.css" rel="stylesheet"/>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.3/js/select2.min.js"></script>

    <!-- Latest compiled and minified CSS -->
    <link rel="stylesheet"
          href="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-select/1.11.2/css/bootstrap-select.min.css">

    <!-- Latest compiled and minified JavaScript -->
    <script src="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-select/1.11.2/js/bootstrap-select.min.js"></script>


{% endblock %}

{% block rightPane %}
    <div class="x_panel">
        <div class="x_title">
            <h2>
                <i class="fa fa-binoculars"></i>
                Request On-Duty
            </h2>
            <ul class="nav navbar-right panel_toolbox">
                <li><a class="btn1 btn1-secondary" href="{% url 'viewmyodrequest' %}">View &
                    Delete</a>
                </li>
            </ul>
            <div class="clearfix"></div>
        </div>
        <div class="x_content">
            <div class="row">
                <ul class="nav nav-tabs bar_tabs">
                    <li {% if selected_tab == "full" %}class="active" {% else %}
                        class="" {% endif %}>
                        <a aria-expanded="true"
                           id="full"
                           data-toggle="tab" name="od_tab">
                            Full Day ODs
                        </a>
                    </li>
                    <li {% if selected_tab == "hour" %}class="active" {% else %}
                        class="" {% endif %}>
                        <a aria-expanded="false"
                           id="hour"
                           data-toggle="tab" name="od_tab">
                            Hourly ODs
                        </a>
                    </li>
                </ul>
                <div class="col-md-12 col-sm-12 col-xs-12">
                    {% load static %}
                    {% get_media_prefix as MEDIA_ROOT %}
                    {% if selected_tab == 'full' %}
                        <div class="container" align="center">
                            <div role="alert" class="alert alert-warning alert-dismissible fade in" align="center">
                                <button aria-label="Close" data-dismiss="alert" class="close" type="button"><span
                                        aria-hidden="true">×</span>
                                </button>
                                <p><em><h5> Start and End date are same if it is ONE DAY OD </h5></em></p>
                            </div>
                        </div>
                    {% endif %}
                    <form id="demo-form2" class="form-horizontal form-label-left" method="POST">{% csrf_token %}
                        <div class="form-group">
                            <label class="control-label col-md-3 col-sm-3 col-xs-12">
                                Department
                            </label>
                            <div class="col-md-6 col-sm-6 col-xs-12">
                                <select class="form-control" name="dept" id="dept" data-width="auto"
                                        required>
                                    <option disabled selected>-----------</option>
                                    {% for department in department_list %}
                                        <option value="{{ department.id }}"
                                                data-subtext="{{ department.acronym }}">{{ department }}</option>
                                    {% endfor %}
                                </select>
                            </div>
                        </div>

                        <div class="form-group">
                            <label class="control-label col-md-3 col-sm-3 col-xs-12">
                                Staff
                            </label>
                            <div class="col-md-6 col-sm-6 col-xs-12">
                                <select name="staff" id="staff" class="form-control"
                                        required>
                                    <option disabled selected>-----------</option>
                                </select>
                            </div>
                        </div>
                        {% if selected_tab == 'full' %}
                            <div class="form-group">
                                <label class="control-label col-md-3 col-sm-3 col-xs-12">
                                    Start date
                                </label>
                                <div class="col-md-6 col-sm-6 col-xs-12">
                                    <input id="datepicker" class="form-control" type="text" required readonly>
                                </div>
                            </div>
                            <div class="form-group">
                                <label class="control-label col-md-3 col-sm-3 col-xs-12">
                                    End date
                                </label>
                                <div class="col-md-6 col-sm-6 col-xs-12">
                                    <input id="datepicker1" class="form-control" type="text" required readonly>
                                </div>
                            </div>
                        {% endif %}
                        {% if selected_tab == 'hour' %}
                            <div class="form-group">
                                <label class="control-label col-md-3 col-sm-3 col-xs-12">
                                    Date
                                </label>
                                <div class="col-md-6 col-sm-6 col-xs-12">
                                    <input id="datepicker_hour" class="form-control" type="text" required readonly>
                                </div>
                            </div>
                        {% endif %}
                        <div class="form-group">
                            <label class="control-label col-md-3 col-sm-3 col-xs-12">
                                Reason
                            </label>
                            <div class="col-md-6 col-sm-6 col-xs-12">
                                <textarea id="reason" class="form-control" type="text" name="reason"
                                          maxlength="1500" placeholder="Reason for OD" required></textarea>
                            </div>
                        </div>
                        {% if selected_tab == 'hour' %}
                            <div class="form-group">
                                <label class="control-label col-md-3 col-sm-3 col-xs-12">
                                    Hours
                                </label>
                                <div class="col-md-6 col-sm-6 col-xs-12">
                                    <input id="hourchecked1" type="checkbox" value="1" name="hour">1st hour&nbsp;&nbsp;
                                    <input id="hourchecked2" type="checkbox" value="2" name="hour">2nd hour&nbsp;&nbsp;
                                    <input id="hourchecked3" type="checkbox" value="3" name="hour">3rd hour&nbsp;&nbsp;
                                    <input id="hourchecked4" type="checkbox" value="4" name="hour">4th hour&nbsp;&nbsp;
                                </div>
                                <div class="col-md-6 col-sm-6 col-xs-12">
                                    <input id="hourchecked5" type="checkbox" value="5" name="hour">5th hour&nbsp;&nbsp;
                                    <input id="hourchecked6" type="checkbox" value="6" name="hour">6th hour&nbsp;&nbsp;
                                    <input id="hourchecked7" type="checkbox" value="7" name="hour">7th hour&nbsp;&nbsp;
                                    {#                                    {% if student_regulation.start_year != 2012 %}#}
                                    <input id="hourchecked8" type="checkbox" value="8" name="hour">8th hour&nbsp;
                                    &nbsp;
                                    {#                                    {% endif %}#}
                                </div>
                            </div>
                        {% endif %}
                        <div class="form-group">
                            <label class="control-label col-md-3 col-sm-3 col-xs-12">
                            </label>
                            <div class="col-md-6 col-sm-6 col-xs-12">
                                <button id="add" type="submit" class="btn1 btn-dark-green">Request OD</button>
                            </div>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>

    <form id="dummy_form" method="POST">
        {% csrf_token %}
    </form>

    <script type="text/javascript">

        $(function () {
            $("#datepicker").datepicker({dateFormat: 'dd/mm/yy'});
        });

        {#        beforeShowDay: $.datepicker.noWeekends#}

        $(function () {
            $("#datepicker1").datepicker({dateFormat: 'dd/mm/yy'});
        });

        $(function () {
            $("#datepicker_hour").datepicker({dateFormat: 'dd/mm/yy'});
        });

        {% if after_request %}
            {% if request_success %}
                $(function () {
                    new PNotify({
                        title: 'Success!',
                        text: '{{ reason }}',
                        type: 'success',
                        styling: 'bootstrap3',
                        min_height: "20px",
                        mobile: {'styling': true}
                    });
                });
            {% elif not request_success %}
                $(function () {
                    new PNotify({
                        title: 'Oh Snap!',
                        text: '{{ reason }}',
                        type: 'error',
                        styling: 'bootstrap3',
                        min_height: "20px",
                        mobile: {'styling': true}
                    });
                });
            {% endif %}
        {% endif %}

        {% if error == 'holiday' %}
            $(function () {
                new PNotify({
                    title: 'Warning!',
                    text: {% if selected_tab == 'full' %}'Start or End date cannot be a holiday'
                        {% elif selected_tab == 'hour' %}'Date cannot be a holiday'{% endif %},
                    type: 'error',
                    styling: 'bootstrap3',
                    min_height: "20px",
                    mobile: {'styling': true}
                });
            });
        {% endif %}


        //For getting CSRF token
        function getCookie(name) {
            var cookieValue = null;
            if (document.cookie && document.cookie != '') {
                var cookies = document.cookie.split(';');
                for (var i = 0; i < cookies.length; i++) {
                    var cookie = jQuery.trim(cookies[i]);
                    // Does this cookie string begin with the name we want?
                    if (cookie.substring(0, name.length + 1) == (name + '=')) {
                        cookieValue = decodeURIComponent(cookie.substring(name.length + 1));
                        break;
                    }
                }
            }
            return cookieValue;
        }

        $(document).on("change", '#dept', function (e) {
            var dept = $(this).val();
            //alert(dept)

            $.ajax({
                type: "POST",
                data: {
                    department: dept,
                    csrfmiddlewaretoken: getCookie('csrftoken'),
                },
                url: '{% url 'request_od' %}',
                success: function (data) {
                    $('#staff').empty();
                    $('#staff').append('<option disabled selected>' + '-----------' + '</option>');
                    $.each(data.list, function (key, val) {
                        $('#staff').append('<option value="' + val.id + '">' + val.name + '</option>');
                    })

                }
            });
        });

        $('#reason').focusin(function (e) {
            $('#hourchecked1').prop('checked', false);
            $('#hourchecked2').prop('checked', false);
            $('#hourchecked3').prop('checked', false);
            $('#hourchecked4').prop('checked', false);
            $('#hourchecked5').prop('checked', false);
            $('#hourchecked6').prop('checked', false);
            $('#hourchecked7').prop('checked', false);
            var chosen_date = $('#datepicker_hour').val();
            if (chosen_date == null) {
                return;
            }
            if (chosen_date == '') {
                return;
            }
            //alert(chosen_date);

            $.ajax({
                type: "POST",
                data: {
                    chosen_date: chosen_date,
                    csrfmiddlewaretoken: getCookie('csrftoken'),
                },
                url: '{% url 'request_od' %}',
                success: function (data) {
                    $.each(data.list, function (key, val) {
                        $('#hourchecked' + val).prop('checked', true);
                    });
                    if (data.hours != 0) {
                        //alert('You have already requested od on this date\nYou can modify it');
                    }
                }
            });
        });

        $(document).on("submit", '#demo-form2', function (e) {
            e.preventDefault();
            var staff = $('#staff').val();
            var department = $('#dept').val();
            var reason = $('#reason').val();
            var start_date = $('#datepicker').datepicker('getDate');
            {% if selected_tab == 'full' %}
                var end_date = $('#datepicker1').datepicker('getDate');
                var start = $('#datepicker').datepicker({dateFormat: 'dd-mm-yy'}).val();
                var end = $('#datepicker1').datepicker({dateFormat: 'dd-mm-yy'}).val();
            {% endif %}
            {% if selected_tab == 'hour' %}
                var counter = 0;
                $("input:checkbox[name=hour]").each(function () {
                    if ($(this).is(":checked") == true) {
                        counter = counter + 1;
                    }
                });
                if (counter == 0) {
                    alert('Atleast one hour should be ticked');
                    return;
                }
                if (counter == 8) {
                    alert('To get od for all hours, use FULL DAY OD');
                    return;
                }
            {% endif %}
            if (department == null) {
                alert('Select department');
                return;
            }
            if (staff == null) {
                alert('Select staff');
                return;
            }

            {% if selected_tab == 'full' %}
                if (start_date > end_date) {
                    alert('Start date cannot exceed end date');
                    $('#datepicker').val("");
                    $('#datepicker1').val("");
                    return;
                }
            {% endif %}
            if (reason.length == 0) {
                alert('Reason for OD is mandatory');
                return;
            }

            {% if selected_tab == 'full' %}
                var $hiddenInput = $('<input/>', {
                    type: 'hidden',
                    value: getCookie('csrftoken'),
                    name: 'csrfmiddlewaretoken'
                });
                $hiddenInput.appendTo('form');

                var $hiddenInput = $('<input/>', {type: 'hidden', value: staff, name: 'staff'});
                $hiddenInput.appendTo('form');

                var $hiddenInput = $('<input/>', {type: 'hidden', value: department, name: 'dept'});
                $hiddenInput.appendTo('form');

                var $hiddenInput = $('<input/>', {type: 'hidden', value: $('#reason').val(), name: 'reason'});
                $hiddenInput.appendTo('form');

                var $hiddenInput = $('<input/>', {type: 'hidden', value: $('#datepicker').val(), name: 'start_date'});
                $hiddenInput.appendTo('form');

                var $hiddenInput = $('<input/>', {type: 'hidden', value: $('#datepicker1').val(), name: 'end_date'});
                $hiddenInput.appendTo('form');

                $('#dummy_form').submit();
            {% elif selected_tab == 'hour' %}
                var $hiddenInput = $('<input/>', {
                    type: 'hidden',
                    value: getCookie('csrftoken'),
                    name: 'csrfmiddlewaretoken'
                });
                $hiddenInput.appendTo('form');

                var $hiddenInput = $('<input/>', {type: 'hidden', value: staff, name: 'staff'});
                $hiddenInput.appendTo('form');

                var $hiddenInput = $('<input/>', {type: 'hidden', value: department, name: 'dept'});
                $hiddenInput.appendTo('form');

                var $hiddenInput = $('<input/>', {type: 'hidden', value: $('#reason').val(), name: 'reason'});
                $hiddenInput.appendTo('form');

                var $hiddenInput = $('<input/>', {type: 'hidden', value: $('#datepicker_hour').val(), name: 'date'});
                $hiddenInput.appendTo('form');

                $('#demo-form2').submit();
            {% endif %}
        });

        $('document').ready(function () {
            $('[name="od_tab"]').click(function () {

                var $hiddenInput = $('<input/>', {
                    type: 'hidden',
                    value: getCookie('csrftoken'),
                    name: 'csrfmiddlewaretoken'
                });
                $hiddenInput.appendTo('form');

                var $hiddenInput = $('<input/>', {type: 'hidden', value: this.id, name: 'selected_tab'});
                $hiddenInput.appendTo('form');

                $('#dummy_form').submit();

            });
        });

    </script>

{% endblock %}